#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Ecrit par Jean-Baptiste Théou (Alias Anbreizh) et Michael Strecke
# Copyright 2005-2008 Jean-Baptiste Théou

    #################################
    #         EASYCAM               #
    #################################
#
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA 02111-1307 USA
### Interface gtk

import os, sys,commands
import gettext
import gnome.ui
import gtk, gtk.glade
import xml
sys.path.append('/usr/share/EasyCam2/')
import easycamconfig

APPNAME="Easy Cam"
APPVERSION=os.popen("sudo apt-cache show easycam2-core | grep Version").readlines()[0][9:16]

gtk.glade.bindtextdomain("easycam","/usr/share/EasyCam2/locale")
gtk.glade.textdomain("easycam")
gettext.bindtextdomain("easycam","/usr/share/EasyCam2/locale")
gettext.textdomain("easycam")
_ = gettext.gettext

def simpleErrorMessageDialog(message):
   d = gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE,message)
   d.run()
   d.destroy()

class MakeGui:
    ##
    # storage for selected USB id
    installid = ""

#### Initialisation : 
    def __init__( self ):
        gnome.init( APPNAME, APPVERSION )
        self.gui = gtk.glade.XML( "/usr/share/EasyCam2/gtk/easycam.glade" )
        self.gui.get_widget( "EasyCamwindows" ).connect( "delete_event", self.destroy )
        self.gui.signal_autoconnect( self )
        self.gui.get_widget( "druidpagestart1" ).show()

    def hidewindow( self, widget, data=None):
        self.about.hide()
	print 'ok'
        return True

#### Définitions pour la destruction des fenêtres

    def destroy( self, widget, data=None ):
        gtk.main_quit()
    
    def on_quit_activate(self, gui ):
        gtk.main_quit()

    def on_druidpagestart1_cancel( self, widget, gui ):
        gtk.main_quit()
    
    def on_druidpagestandard1_cancel( self, widget, gui ):
        gtk.main_quit()
        
    def on_druidpagestandard2_cancel( self, widget, gui ):
        gtk.main_quit()
        
    def on_druidpagefinish1_finish (self, widget, gui):
        gtk.main_quit()
    
    def on_druid1_cancel( self, gui ):
        gtk.main_quit()

#### Définitions de gestion de l'interface graphique

    def on_about_activate( self, gui ):
	self.about = gtk.AboutDialog()
	self.about.set_version(APPVERSION)
	self.about.set_name(_("Easycam"))
	self.about.set_copyright(_("Copyright 2005-2008 Jean-Baptiste Théou et Michael Strecke"))
	self.about.set_license("GPL :  \n This program is free software; you can redistribute it and/or modify it under\n the terms of the GNU General Public License as published by the Free Software\n Foundation; either version 2 of the License, or (at your option) any later\n version. This program is distributed in the hope that it will be useful, but WITHOUT\n ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS\n FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more\n details. You should have received a copy of the GNU General Public License along with\n this program; if not, write to the Free Software Foundation, Inc., 59 Temple\n Place, Suite 330, Boston, MA 02111-1307 USA")
	self.about.set_website("http://blognux.free.fr")
	self.about.set_website_label(_("Le blog d'Easycam"))
	self.about.set_authors(["Jean-Baptiste Théou", "Michael Strecke"])
	self.about.set_documenters(["Jean-Baptiste Théou", "Michael Strecke"])
	self.about.set_artists(["Jean-Baptiste Théou"])
	self.about.set_translator_credits("Allemand : Michael Streche,François Blondel ; Portugais : AliasBody ; Anglais : Théou Jean-Baptiste, Clément Bebin, Romain Roussel et Ségolène Dano ; Italien : Alessandro Benedetto ; Espanol : Milton Jimenez")
	#self.about.set_logo("/usr/share/EasyCam2/gtk/video-preview.png")
	self.about.run()	
	self.about.show()
	self.about.destroy()

    def on_webcam_activate (self, gui):
	os.system('cheese')

    def on_documentation1_activate (self, gui):
	os.system("evince /usr/share/EasyCam2/docs/easycam-en.pdf")


	
    
#### Définitions de gestion de la comboxbox de sélection de la webcam (Page 2) 

    def on_druidpagestart1_next( self, widget, gui ):
        global cf
        combobox = self.gui.get_widget( "comboboxentry1" )
        cnt = 0
	f = os.popen("lsusb","r")
        for line in f.readlines():
            id = line[23:32]
	    info = cf.getDriverListByID(id)[0]
	    if info :
            	for driver in info :	# put id only in list, if we know how to handle it
	    		combobox.insert_text( 0, cf.getCameraName(id) )
             		cnt += 1  
        f.close()
        if cnt:
           combobox.connect( 'changed', self.changed_cb )
           combobox.set_active( 0 )
        else:
           simpleErrorMessageDialog( _( u"Aucune caméra trouvée ou caméra non compatible") )
           gtk.main_quit()

    def changed_cb( self, combobox ):
        model = combobox.get_model()
        index = combobox.get_active()
        self.installname = model[index][0] # USB name of selected device


    def on_go_clicked ( self, gui ):
        global cf	# holds the config info
	print 'GO !'        
        identi = ""
	error = 0
        info = cf.getDriverListByID(cf.getIDByName(self.installname))[0]
        if info:
            if  len(info) == 1:
                moreinfo = cf.getDriverInfo(info[0])
                identi = moreinfo['name']
            else:
		simpleErrorMessageDialog( _( u"Plusieurs drivers sont disponible pour votre webcam ... Ce qui est un problème pour la procédure d'installation d'Easycam. Rendez-vous sur le blog d'Easycam pour résoudre ce soucis : http://blognux.free.fr ") )
		gtk.main_quit()
		error = 1
	else:                       # there is NO drive for this camera
		pass                # do nothing, perhaps an info window would be nice
	if error == 0:
		self.progressbar = self.gui.get_widget("progressbar1")
		self.texterror = self.gui.get_widget("label9")	
		self.progressbar.set_text( _("Installation du driver en cours ...") )
		self.progressbar.pulse()
		os.system("python /usr/share/EasyCam2/core.py -i %s" %identi)
		self.progressbar.set_text( _("Drivers installé !") )    
	



##### Code d'initialisation de l'interface :


if __name__ == "__main__":
    ui = MakeGui()
    error = 0
    # Loading config from easycam.xml
    try:
        cf = easycamconfig.ConfigInfo()
    except IOError:
        # config file is missing
        simpleErrorMessageDialog( _( u"Le fichier de configuration n'a pas été détecter!\nReinstallez easycam"))
        error = 1
    except xml.parsers.expat.ExpatError:
        # error in XML syntax
        simpleErrorMessageDialog( _( u"Le fichier de configuration est défectueux.\nReinstallez easycam") )
        error = 1
    if error == 0:
        ui.gui.get_widget( "EasyCamwindows" ).show()
        gtk.main()
